Index: /branches/2.2/jabberit_messenger/jmessenger/js/trophyim.mini.js
===================================================================
--- /branches/2.2/jabberit_messenger/jmessenger/js/trophyim.mini.js	(revision 3228)
+++ /branches/2.2/jabberit_messenger/jmessenger/js/trophyim.mini.js	(revision 3264)
@@ -169,5 +169,5 @@
 setComposing();}});var winChatBox={id_window:"window_chat_area_"+barejid,barejid:barejid,width:387,height:375,top:TrophyIM.posWindow.top,left:TrophyIM.posWindow.left,draggable:true,visible:"display",resizable:true,zindex:loadscript.getZIndex(),title:titleWindow,closeAction:"hidden",content:_content}
 _win=_winBuild(winChatBox);loadscript.notification(barejid);loadscript.getPhotoUser(barejid);_textarea.focus();return(_messages=_win.content().firstChild);},makeChatRoom:function()
-{var jidChatRoom=arguments[0];var titleWindow="ChatRoom - "+arguments[1];var paramsChatRoom={'idChatRoom':jidChatRoom+"__roomChat",'jidTo':jidChatRoom,'lang_Send':i18n.SEND,'lang_Leave_ChatRoom':i18n.LEAVE_CHATROOM,'path_jabberit':path_jabberit};TrophyIM.posWindow.top=TrophyIM.posWindow.top+10;if(TrophyIM.posWindow.top>200)
+{var jidChatRoom=arguments[0];var titleWindow="ChatRoom - "+unescape(arguments[1]);var paramsChatRoom={'idChatRoom':jidChatRoom+"__roomChat",'jidTo':jidChatRoom,'lang_Send':i18n.SEND,'lang_Leave_ChatRoom':i18n.LEAVE_CHATROOM,'path_jabberit':path_jabberit};TrophyIM.posWindow.top=TrophyIM.posWindow.top+10;if(TrophyIM.posWindow.top>200)
 TrophyIM.posWindow.top=100;TrophyIM.posWindow.left=TrophyIM.posWindow.left+5;if(TrophyIM.posWindow.left>455)
 TrophyIM.posWindow.left=400;var _content=document.createElement('div');_content.innerHTML=loadscript.parse("chat_room","chatRoom.xsl",paramsChatRoom);_content=_content.firstChild;var _messages=_content.firstChild.firstChild;var _textarea=_content.getElementsByTagName('textarea').item(0);var _send=_content.getElementsByTagName('input').item(0);var _leaveChatRoom=_content.getElementsByTagName('input').item(1);var _send_message=function()
Index: /branches/2.2/jabberit_messenger/jmessenger/js/trophyim.js
===================================================================
--- /branches/2.2/jabberit_messenger/jmessenger/js/trophyim.js	(revision 3228)
+++ /branches/2.2/jabberit_messenger/jmessenger/js/trophyim.js	(revision 3264)
@@ -1037,5 +1037,5 @@
     {
     	var jidChatRoom = arguments[0];
-    	var titleWindow	= "ChatRoom - " + arguments[1];
+    	var titleWindow	= "ChatRoom - " + unescape(arguments[1]);
     	
     	var paramsChatRoom =
Index: /branches/2.2/jabberit_messenger/jmessenger/js/strophe.mini.js
===================================================================
--- /branches/2.2/jabberit_messenger/jmessenger/js/strophe.mini.js	(revision 3261)
+++ /branches/2.2/jabberit_messenger/jmessenger/js/strophe.mini.js	(revision 3264)
@@ -24,4 +24,9 @@
 {var func=this;return function(){var newargs=[arg];for(var i=0;i<arguments.length;i++){newargs.push(arguments[i]);}
 return func.apply(this,newargs);};};}
+if(!Array.prototype.indexOf)
+{Array.prototype.indexOf=function(elt)
+{var len=this.length;var from=Number(arguments[1])||0;from=(from<0)?Math.ceil(from):Math.floor(from);if(from<0){from+=len;}
+for(;from<len;from++){if(from in this&&this[from]===elt){return from;}}
+return-1;};}
 (function(callback){var Strophe;function $build(name,attrs){return new Strophe.Builder(name,attrs);}
 function $msg(attrs){return new Strophe.Builder("message",attrs);}
Index: /branches/2.2/jabberit_messenger/jmessenger/js/strophe.js
===================================================================
--- /branches/2.2/jabberit_messenger/jmessenger/js/strophe.js	(revision 3261)
+++ /branches/2.2/jabberit_messenger/jmessenger/js/strophe.js	(revision 3264)
@@ -458,5 +458,4 @@
  */
 
-/*
 if (!Array.prototype.indexOf)
 {
@@ -480,5 +479,4 @@
     };
 }
-*/
 
 /* All of the Strophe globals are defined in this special function below so
Index: /branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.js
===================================================================
--- /branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.js	(revision 3228)
+++ /branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.js	(revision 3264)
@@ -1349,5 +1349,5 @@
 			var nameRoom	= _room.getAttribute( 'from' );
 
-			_ROOM.setAttribute( 'nameRoom', (nameRoom.substring(0, nameRoom.indexOf("@"))).toUpperCase() );
+			_ROOM.setAttribute( 'nameRoom', unescape((nameRoom.substring(0, nameRoom.indexOf("@"))).toUpperCase()) );
 			_JIDROOM.appendChild( _xml.createTextNode(nameRoom) );
 			_ROOM.appendChild( _JIDROOM );
Index: /branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.mini.js
===================================================================
--- /branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.mini.js	(revision 3228)
+++ /branches/2.2/jabberit_messenger/jmessenger/js/jscode/loadIM.mini.js	(revision 3264)
@@ -280,5 +280,5 @@
 {_roomsCount++;var _ROOM=_xml.createElement('room')
 var _JIDROOM=_xml.createElement('jidRoom')
-var nameRoom=_room.getAttribute('from');_ROOM.setAttribute('nameRoom',(nameRoom.substring(0,nameRoom.indexOf("@"))).toUpperCase());_JIDROOM.appendChild(_xml.createTextNode(nameRoom));_ROOM.appendChild(_JIDROOM);var _fields=_room.getElementsByTagName('field');for(var f=0;f<_fields.length;f++)
+var nameRoom=_room.getAttribute('from');_ROOM.setAttribute('nameRoom',unescape((nameRoom.substring(0,nameRoom.indexOf("@"))).toUpperCase()));_JIDROOM.appendChild(_xml.createTextNode(nameRoom));_ROOM.appendChild(_JIDROOM);var _fields=_room.getElementsByTagName('field');for(var f=0;f<_fields.length;f++)
 {if(_fields[f].getAttribute('var'))
 {if(_fields[f].firstChild.hasChildNodes()&&_fields[f].getAttribute('var')=='muc#roominfo_description')