Index: branches/2.2/mobile/inc/class.ui_mobilecc.inc.php
===================================================================
--- branches/2.2/mobile/inc/class.ui_mobilecc.inc.php	(revision 1499)
+++ branches/2.2/mobile/inc/class.ui_mobilecc.inc.php	(revision 3268)
@@ -163,5 +163,14 @@
 			else { //Só pego os dados completos caso haja resultado na busca
 				if($this->page_info['actual_catalog']!="bo_group_manager") { //Se não for grupo, tenho que ordenar as connections
-					$entries = $this->bo->get_multiple_entries($ids,array("names_ordered"=>true,"uidnumber"=>true,"id_contact"=>true,"connections"=>true));
+
+                                    $display = "none";
+                                    if(isset($GLOBALS['phpgw_info']['user']['preferences']['contactcenter']['cell']) && $GLOBALS['phpgw_info']['user']['preferences']['contactcenter']['cell'] == 1)
+                                    {
+                                        $_SESSION['phpgw_info']['user']['preferences']['contactcenter']['cellShow'] = true;
+                                        $display = "inline";
+					$entries = $this->bo->get_multiple_entries($ids,array("names_ordered"=>true,"uidnumber"=>true,"id_contact"=>true,"companies"=>true,"connections"=>true));
+                                    }else {
+                                        $entries = $this->bo->get_multiple_entries($ids,array("names_ordered"=>true,"uidnumber"=>true,"id_contact"=>true,"connections"=>true));
+                                    }
 					/**
 					 * As entradas vindas de get_multiple_entries não vem com as connections
@@ -302,7 +311,9 @@
 				if($this->page_info['actual_catalog']!="bo_group_manager") {
 					$p->set_var(
-							array('lang_people_name' => lang("Name"),
-								'lang_phone' => lang("Phone"),
-								'lang_mail' => lang("Email")));
+							array('lang_people_name'	=> lang("Name"),
+								'lang_phone'		=> lang("Phone"),
+								'lang_mobile'		=> "Celular", //lang("Mobile"),
+                                                                'display'               => $display,
+								'lang_mail'		=> lang("Email")));
 					$p->parse('header','people_header',True);
 				}
@@ -320,5 +331,8 @@
 					if(($this->page_info['actual_catalog']!="bo_group_manager") &&
 							 (strpos($this->page_info['actual_catalog'],'bo_global_ldap_catalog')===false)){ //People
-						$var = array('row_nome'=>$entry['names_ordered']);
+						$var = array(
+								'row_nome'	=> $entry['names_ordered'],
+								'row_mobile'	=> $entry['companies']['company1']['celPhone']
+							);
 						$conn1 = array_shift($entry['connections']);
 						if(($conn1==NULL)||($conn1['connection_is_default']!=1)) {
@@ -352,5 +366,5 @@
 					}
 					else { //Ldap
-						$var = array('row_nome'=>$entry['names_ordered'][0]);
+						$var = array('row_nome'=>$entry['names_ordered'][0],'row_mobile'=> $entry['companies']['company1']['celPhone']);
 						$conn1 = array_shift($entry['connections']);
 						if(($conn1==NULL)) {
Index: branches/2.2/mobile/index.php
===================================================================
--- branches/2.2/mobile/index.php	(revision 1851)
+++ branches/2.2/mobile/index.php	(revision 3268)
@@ -4,6 +4,4 @@
 	$phpgw_info = array();
 	$GLOBALS['sessionid'] = isset($_GET['sessionid']) ? $_GET['sessionid'] : @$_COOKIE['sessionid'];
-
-	$_SESSION['phpgw_info']['user']['preferences']['contactcenter']['cellShow'] = true;
 
         $proxies=explode(',',$_SERVER['HTTP_X_FORWARDED_HOST']);
Index: branches/2.2/mobile/templates/default/cc_main.tpl
===================================================================
--- branches/2.2/mobile/templates/default/cc_main.tpl	(revision 1499)
+++ branches/2.2/mobile/templates/default/cc_main.tpl	(revision 3268)
@@ -37,6 +37,7 @@
 
 <!-- BEGIN people_header -->
-				<td width="60%" align="center">{lang_people_name}</td>
+				<td width="40%" align="center">{lang_people_name}</td>
 				<td width="20%" align="center">{lang_phone}</td>
+				<td width="20%" align="center" style="display: {display};">{lang_mobile}</td>
 				<td width="20%" align="center">{lang_mail}</td>
 <!-- END people_header -->
@@ -52,4 +53,5 @@
 		<td>{row_nome}</td>
 		<td align="center">{row_telefone}</td>
+		<td align="center" style="display: {display};">{row_mobile}</td>
 		<td align="center"><a href="{form_action}&input_to={row_nome}&input_to_mail={row_email}&cc_mob=1">{row_email}</a></td>
 